> For the complete documentation index, see [llms.txt](https://docs.mclimate.eu/mclimate-lorawan-devices/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mclimate.eu/mclimate-lorawan-devices/devices/mclimate-t-valve-lorawan/decoding-and-bacnet-object-mapping/bacnet-codec-and-definition-files/multitech.md).

# Multitech

## Creation procedure

#### Import steps

1. **Payload Management → Sensor Definitions → Import**\
   *Manufacturer*: **MClimate**  *Sensor Type*: **XX**\
   \
   XX - the specific name of the sensor you are currently importing
2. Select **both files**:
   * `mclimate-aqi-codec.js`
   * `mclimate-aqi-definition.json`
3. Click **Import**, then **Save & Apply** – the gateway will create read-only Input objects for telemetry and writable Value objects for every `"downlink": true` property.

{% hint style="warning" %}
Take note the example file below ends with 2 lines, that are the "decoder", "encoder" variable names. These are an example and need to match the names you have given them when actually importing them in the Multitech Gateway.
{% endhint %}

{% hint style="warning" %}
In order for the BACnet integration to work, you would need to import both the code below for the Codec file (in the form of a JS file) and the code for the Definition file after it (in the form of a JSON file).
{% endhint %}

### Multitech BACnet Codec file

```json
// DataCake
function Decoder(bytes, port){
    var decoded = decodeUplink({ bytes: bytes, fPort: port }).data;
    return decoded;
}

// Milesight
function Decode(port, bytes){
    var decoded = decodeUplink({ bytes: bytes, fPort: port }).data;
    return decoded;
}

// The Things Industries / Main
function decodeUplink(input) {
	var bytes = input.bytes;
	var data = {};
	var messageTypes = ['keepalive', 'testButtonPressed', 'floodDetected', 'controlButtonPressed', 'fraudDetected'];

	function shortPackage(byteArray, data) {
		data.reason = 'keepalive';
		data.waterTemp = (byteArray[0] & 0xFF) / 2;
			data.valveState = !!(byteArray[1] & 0x80);
			data.ambientTemp = ((byteArray[1] & 0x7F) - 20) / 2;
		return data;
	}
	function longPackage(byteArray, data) {
		data.reason = messageTypes[(byteArray[0] >> 5) & 0x7];  // Extract bits 7:5 using right shift and mask
			data.boxTamper = !!(byteArray[0] & (1 << 3));             // Extract bit 3
			data.floodDetectionWireState = !!(byteArray[0] & (1 << 2)); // Extract bit 2
			data.flood = !!(byteArray[0] & (1 << 1));                 // Extract bit 1
			data.magnet = !!(byteArray[0] & 1);                       // Extract bit 0
			data.alarmValidated = !!(byteArray[1] & (1 << 7));        // Extract bit 7
			data.manualOpenIndicator = !!(byteArray[1] & (1 << 6));   // Extract bit 6
			data.manualCloseIndicator = !!(byteArray[1] & (1 << 5));  // Extract bit 5
			data.softwareVersion = byteArray[1] & 0x1F;            // Extract bits 4:0
			data.closeTime = byteArray[2];                            // Byte 2
			data.openTime = byteArray[3];                             // Byte 3
			data.battery = ((byteArray[4] * 8) + 1600) / 1000;        // Byte 4, battery calculation
		return data;
	}

	function handleResponse(bytes, data) {
		var commands = bytes.map(function (byte) {
			return ("0" + byte.toString(16)).substr(-2);
		});
		var command_len = 0;
		commands.map(function (command, i) {
			switch (command) {
				case '0e':
					{
						command_len = 4;
						var openingTime = (parseInt(commands[i + 1], 16) << 8) | parseInt(commands[i + 2], 16);
						var closingTime = (parseInt(commands[i + 3], 16) << 8) | parseInt(commands[i + 4], 16);
						data.openCloseTimeExtended = { 'openingTime': Number(openingTime), 'closingTime': Number(closingTime) };
					}
					break;
				case '0f':
					{
						command_len = 1;
						data.emergencyOpenings = parseInt(commands[i + 1], 16);
					}
					break;
				case '10':
					{
						command_len = 1;
						data.floodAlarmTime = parseInt(commands[i + 1], 16);
					}
					break;
				case '11':
					{
						command_len = 1;
						data.workingVoltage = parseInt(commands[i + 1], 16);
					}
					break;
				case '12':
					{
						command_len = 1;
						data.keepAliveTime = parseInt(commands[i + 1], 16);
					}
					break;
				case '13':
					{
						command_len = 1;
						data.deviceFloodSensor = parseInt(commands[i + 1], 16);
					}
					break;
				case '16':
					{
						command_len = 1;
						var commandResponse = parseInt(commands[i + 1], 16);
						var periodInMinutes = commandResponse * 5 / 60;
						data.joinRetryPeriod = periodInMinutes;
					}
					break;
				case '18':
					{
						command_len = 1;
						data.uplinkType = parseInt(commands[i + 1], 16);
					}
					break;
				case '1a':
					{
						command_len = 2;
						var wdpC = commands[i + 1] == '00' ? false : parseInt(commands[i + 1], 16);
						var wdpUc = commands[i + 2] == '00' ? false : parseInt(commands[i + 2], 16);
						data.watchDogParams = { 'wdpC': wdpC, 'wdpUc': wdpUc };
					}
					break;
				case 'a0':

					command_len = 4;
					var fuota_address = (parseInt(commands[i + 1], 16) << 24) | (parseInt(commands[i + 2], 16) << 16) | (parseInt(commands[i + 3], 16) << 8) | parseInt(commands[i + 4], 16);
					var fuota_address_raw = (parseInt(commands[i + 1], 16) << 24) | (parseInt(commands[i + 2], 16) << 16) | (parseInt(commands[i + 3], 16) << 8) | parseInt(commands[i + 4], 16);
					data.fuota = { 'fuota_address': fuota_address, 'fuota_address_raw': fuota_address_raw };
					break;
				default:
					break;
			}
			commands.splice(i, command_len);
		});
		return data;
	}

	if (bytes.length == 5) {
		data = longPackage(bytes, data);
	} else if (bytes.length == 2) {
		data = shortPackage(bytes, data);
	} else {
		data = longPackage(bytes, data);
		bytes = bytes.slice(5);
		data = handleResponse(bytes, data);
	}
	return { data: data };
}
```

### Multitech BACnet Definition file

```json
{
  "description": "MClimate T-Valve (T-Valve) – BACnet mapping",
  "properties": {

    "reason"                     : { "type": "string"                      },
    "waterTemp"                  : { "type": "float",  "units": "celsius" },
    "valveState"                 : { "type": "bool"                        },
    "ambientTemp"                : { "type": "float",  "units": "celsius" },

    "boxTamper"                  : { "type": "bool"                        },
    "floodDetectionWireState"    : { "type": "bool"                        },
    "flood"                      : { "type": "bool"                        },
    "magnet"                     : { "type": "bool"                        },
    "alarmValidated"             : { "type": "bool"                        },
    "manualOpenIndicator"        : { "type": "bool"                        },
    "manualCloseIndicator"       : { "type": "bool"                        },
    "softwareVersion"            : { "type": "uint8"                       },
    "closeTime"                  : { "type": "uint8",  "units": "seconds"  },
    "openTime"                   : { "type": "uint8",  "units": "seconds"  },
    "battery"                    : { "type": "float",  "units": "V"        },

    "openCloseTimeExtended"      : { "type": "object"                      },
    "emergencyOpenings"          : { "type": "uint8"                       },
    "floodAlarmTime"             : { "type": "uint8",  "units": "minutes"  },
    "workingVoltage"             : { "type": "uint8",  "units": "V"        },
    "keepAliveTime"              : { "type": "uint8",  "units": "minutes"  },
    "deviceFloodSensor"          : { "type": "uint8"                       },
    "joinRetryPeriod"            : { "type": "float",  "units": "minutes"  },
    "uplinkType"                 : { "type": "uint8"                       },
    "watchDogParams"             : { "type": "object"                      },
    "fuota"                      : { "type": "object"                      }
  },

  "decoder": "mclimate-t-valve-codec.js",
  "encoder": "mclimate-t-valve-codec.js"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mclimate.eu/mclimate-lorawan-devices/devices/mclimate-t-valve-lorawan/decoding-and-bacnet-object-mapping/bacnet-codec-and-definition-files/multitech.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
